The BOOST_PP_LIST_FOLD_LEFT_d macro folds (or accumulates) the elements of a list left-to-right. It reenters BOOST_PP_WHILE with maximum efficiency.

#### Usage

BOOST_PP_LIST_FOLD_LEFT_ ## d(op, state, list)

#### Arguments

d
  The next available BOOST_PP_WHILE iteration.
op
  A ternary operation of the form op(d, state, elem). This macro is called for each element in list--each time returning a new state. This operation is expanded by BOOST_PP_LIST_FOLD_LEFT with the next available BOOST_PP_WHILE iteration, the current state, and the current element.
state
  The initial state of the fold.
list
  The list to be folded.

#### Remarks

For the list, (0, (1, (2, BOOST_PP_NIL))), this macro expands to:
op(d, op(d, op(d, state, 0), 1), 2)

#### See Also

- BOOST_PP_LIST_FOLD_LEFT

#### Requirements

Header: <boost/preprocessor/list/fold_left.hpp>

#### Sample Code

    #include <boost/preprocessor/cat.hpp>
    #include <boost/preprocessor/list/fold_left.hpp>

    #define L1 (a, (b, (c, BOOST_PP_NIL)))
    #define L2 (L1, (L1, (L1, BOOST_PP_NIL)))

    #define OP(d, state, x) (BOOST_PP_LIST_FOLD_LEFT_ ## d(OP_2, _, x), state)
    #define OP_2(d, state, x) BOOST_PP_CAT(state, x)

    BOOST_PP_LIST_FOLD_LEFT(OP, BOOST_PP_NIL, L2)
    /*
       expands to:
       (_abc, (_abc, (_abc, BOOST_PP_NIL)))
    */